"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.xAdd = void 0;
const op_1 = require("../../json-patch/op");
const json_pointer_1 = require("../../json-pointer");
const util_1 = require("./util");
const xAdd = (add, op) => {
    if (json_pointer_1.isRoot(add.path))
        return null;
    if (json_pointer_1.isRoot(op.path))
        return op;
    const lastIndex = add.path.length - 1;
    const lastStep = add.path[lastIndex];
    const isLastStepNumberLike = json_pointer_1.isValidIndex(lastStep);
    if (json_pointer_1.isChild(add.path, op.path) && !isLastStepNumberLike)
        return null;
    if (isLastStepNumberLike) {
        const newPath = util_1.bumpArrayPath(add.path, op.path);
        const newFrom = op.from ? util_1.bumpArrayPath(add.path, op.from) : undefined;
        if (newPath || newFrom) {
            const operation = Object.assign(Object.assign({}, op.toJson()), { path: newPath ? json_pointer_1.formatJsonPointer(newPath) : op.path });
            if (newFrom)
                operation.from = json_pointer_1.formatJsonPointer(newFrom);
            return op_1.operationToOp(operation);
        }
    }
    return op;
};
exports.xAdd = xAdd;
