"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyPatch = exports.applyOps = exports.applyOp = void 0;
const util_1 = require("../util");
const op_1 = require("../op");
function applyOp(doc, op, mutate) {
    if (!mutate)
        doc = util_1.deepClone(doc);
    return op.apply(doc);
}
exports.applyOp = applyOp;
function applyOps(doc, ops, mutate) {
    if (!mutate)
        doc = util_1.deepClone(doc);
    const res = [];
    const length = ops.length;
    for (let i = 0; i < length; i++) {
        const opResult = ops[i].apply(doc);
        doc = opResult.doc;
        res.push(opResult);
    }
    return { doc, res };
}
exports.applyOps = applyOps;
function applyPatch(doc, patch, mutate) {
    const result = applyOps(doc, patch.map(op_1.operationToOp), mutate);
    return result;
}
exports.applyPatch = applyPatch;
