import { Path } from '../../json-pointer';
import { Operation, OpType } from '../types';
import { OPCODE } from './constants';
export declare type PackedOp = [OPCODE, string | Path] | [OPCODE, string | Path, object];
export declare abstract class AbstractOp<O extends OpType = OpType> {
    readonly op: O;
    readonly path: Path;
    readonly from?: Path;
    constructor(op: O, path: Path);
    abstract apply(doc: unknown): {
        doc: unknown;
        old?: unknown;
    };
    abstract toJson(): Operation;
    abstract toPacked(): PackedOp;
}
