import { AbstractOp } from './AbstractOp';
import { OperationAdd } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedAddOp = [OPCODE.add, string | Path, {
    v: unknown;
}];
export declare class OpAdd extends AbstractOp<'add'> {
    readonly value: unknown;
    constructor(path: Path, value: unknown);
    apply(doc: unknown): {
        doc: unknown;
        old: any;
    };
    toJson(): OperationAdd;
    toPacked(): PackedAddOp;
}
