import { AbstractSecondOrderPredicateOp } from './AbstractSecondOrderPredicateOp';
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { PackedOp } from './AbstractOp';
import { OperationAnd } from '../types';
import { OPCODE } from './constants';
import { Path } from '../../json-pointer';
export declare type PackedAndOp = [OPCODE.and, string | Path, {
    o: PackedOp[];
}];
export declare class OpAnd extends AbstractSecondOrderPredicateOp<'and'> {
    readonly ops: AbstractPredicateOp[];
    constructor(path: Path, ops: AbstractPredicateOp[]);
    test(doc: unknown): boolean;
    toJson(): OperationAnd;
    toPacked(): PackedAndOp;
}
