"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpAnd = void 0;
const AbstractSecondOrderPredicateOp_1 = require("./AbstractSecondOrderPredicateOp");
const json_pointer_1 = require("../../json-pointer");
class OpAnd extends AbstractSecondOrderPredicateOp_1.AbstractSecondOrderPredicateOp {
    constructor(path, ops) {
        super('and', path, ops);
        this.ops = ops;
    }
    test(doc) {
        for (const op of this.ops)
            if (!op.test(doc))
                return false;
        return true;
    }
    toJson() {
        const op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            apply: this.ops.map((op) => op.toJson()),
        };
        return op;
    }
    toPacked() {
        return [43, this.path, { o: this.ops.map((op) => op.toPacked()) }];
    }
}
exports.OpAnd = OpAnd;
