import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OperationContains } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedContainsOp = [OPCODE.contains, string | Path, {
    v: string;
    i?: 1;
}];
export declare class OpContains extends AbstractPredicateOp<'contains'> {
    readonly value: string;
    readonly ignore_case: boolean;
    constructor(path: Path, value: string, ignore_case: boolean);
    test(doc: unknown): boolean;
    toJson(): OperationContains;
    toPacked(): PackedContainsOp;
}
