import { AbstractOp } from './AbstractOp';
import { OperationCopy } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedCopyOp = [OPCODE.copy, string | Path, {
    f: string | Path;
}];
export declare class OpCopy extends AbstractOp<'copy'> {
    readonly from: Path;
    constructor(path: Path, from: Path);
    apply(doc: unknown): {
        doc: unknown;
        old: any;
    };
    toJson(): OperationCopy;
    toPacked(): PackedCopyOp;
}
