"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpCopy = void 0;
const AbstractOp_1 = require("./AbstractOp");
const json_pointer_1 = require("../../json-pointer");
const OpAdd_1 = require("./OpAdd");
const util_1 = require("../util");
class OpCopy extends AbstractOp_1.AbstractOp {
    constructor(path, from) {
        super('copy', path);
        this.from = from;
    }
    apply(doc) {
        const { val } = json_pointer_1.find(doc, this.from);
        if (val === undefined)
            throw new Error('NOT_FOUND');
        const add = new OpAdd_1.OpAdd(this.path, util_1.deepClone(val)).apply(doc);
        return add;
    }
    toJson() {
        return {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            from: json_pointer_1.formatJsonPointer(this.from),
        };
    }
    toPacked() {
        const packed = [3, this.path, { f: this.from }];
        return packed;
    }
}
exports.OpCopy = OpCopy;
