import { AbstractOp } from './AbstractOp';
import { OperationExtend } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedExtendOp = [OPCODE.extend, string | Path, {
    p: Record<string, unknown>;
    d?: 1;
}];
export declare class OpExtend extends AbstractOp<'extend'> {
    readonly props: Record<string, unknown>;
    readonly deleteNull: boolean;
    constructor(path: Path, props: Record<string, unknown>, deleteNull: boolean);
    apply(doc: unknown): {
        doc: unknown;
    };
    private extend;
    toJson(): OperationExtend;
    toPacked(): PackedExtendOp;
}
