"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpFlip = void 0;
const AbstractOp_1 = require("./AbstractOp");
const json_pointer_1 = require("../../json-pointer");
class OpFlip extends AbstractOp_1.AbstractOp {
    constructor(path) {
        super('flip', path);
    }
    apply(doc) {
        const ref = json_pointer_1.find(doc, this.path);
        if (ref.obj)
            ref.obj[ref.key] = !ref.val;
        else
            doc = !ref.val;
        return { doc, old: ref.val };
    }
    toJson() {
        const op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
        };
        return op;
    }
    toPacked() {
        const packed = [8, this.path];
        return packed;
    }
}
exports.OpFlip = OpFlip;
