import { OperationIn } from '../types';
import { Path } from '../../json-pointer';
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OPCODE } from './constants';
export declare type PackedInOp = [OPCODE.in, string | Path, {
    v: unknown[];
}];
export declare class OpIn extends AbstractPredicateOp<'in'> {
    readonly value: unknown[];
    constructor(path: Path, value: unknown[]);
    test(doc: unknown): boolean;
    toJson(): OperationIn;
    toPacked(): PackedInOp;
}
