"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpIn = void 0;
const json_pointer_1 = require("../../json-pointer");
const AbstractPredicateOp_1 = require("./AbstractPredicateOp");
const isEqual = require('fast-deep-equal');
class OpIn extends AbstractPredicateOp_1.AbstractPredicateOp {
    constructor(path, value) {
        super('in', path);
        this.value = value;
    }
    test(doc) {
        const { val } = json_pointer_1.find(doc, this.path);
        for (const x of this.value)
            if (isEqual(val, x))
                return true;
        return false;
    }
    toJson() {
        const op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
        return op;
    }
    toPacked() {
        const packed = [33, this.path, { v: this.value }];
        return packed;
    }
}
exports.OpIn = OpIn;
