import { AbstractOp } from './AbstractOp';
import { OperationInc } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedIncOp = [OPCODE.inc, string | Path, {
    v: number;
}];
export declare class OpInc extends AbstractOp<'inc'> {
    readonly inc: number;
    constructor(path: Path, inc: number);
    apply(doc: unknown): {
        doc: unknown;
        old: unknown;
    };
    toJson(): OperationInc;
    toPacked(): PackedIncOp;
}
