"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpInc = void 0;
const AbstractOp_1 = require("./AbstractOp");
const json_pointer_1 = require("../../json-pointer");
class OpInc extends AbstractOp_1.AbstractOp {
    constructor(path, inc) {
        super('inc', path);
        this.inc = inc;
    }
    apply(doc) {
        const ref = json_pointer_1.find(doc, this.path);
        const result = this.inc + Number(ref.val);
        if (ref.obj)
            ref.obj[ref.key] = result;
        else
            doc = result;
        return { doc, old: ref.val };
    }
    toJson() {
        const op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            inc: this.inc,
        };
        return op;
    }
    toPacked() {
        const packed = [9, this.path, { v: this.inc }];
        return packed;
    }
}
exports.OpInc = OpInc;
