import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OperationLess } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedLessOp = [OPCODE.less, string | Path, {
    v: number;
}];
export declare class OpLess extends AbstractPredicateOp<'less'> {
    readonly value: number;
    constructor(path: Path, value: number);
    test(doc: unknown): boolean;
    toJson(): OperationLess;
    toPacked(): PackedLessOp;
}
