"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpLess = void 0;
const AbstractPredicateOp_1 = require("./AbstractPredicateOp");
const json_pointer_1 = require("../../json-pointer");
class OpLess extends AbstractPredicateOp_1.AbstractPredicateOp {
    constructor(path, value) {
        super('less', path);
        this.value = value;
    }
    test(doc) {
        const { val } = json_pointer_1.find(doc, this.path);
        if (typeof val !== 'number')
            return false;
        const test = val < this.value;
        return test;
    }
    toJson() {
        const op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
        return op;
    }
    toPacked() {
        const packed = [34, this.path, { v: this.value }];
        return packed;
    }
}
exports.OpLess = OpLess;
