import { AbstractOp } from './AbstractOp';
import { OperationMerge } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedMergeOp = [OPCODE.merge, string | Path, {
    i: number;
    p?: object;
}];
export declare class OpMerge extends AbstractOp<'merge'> {
    readonly pos: number;
    readonly props: object | null;
    constructor(path: Path, pos: number, props: object | null);
    apply(doc: unknown): {
        doc: unknown;
        old: unknown[];
    };
    private merge;
    toJson(): OperationMerge;
    toPacked(): PackedMergeOp;
}
