import { AbstractOp } from './AbstractOp';
import { OperationMove } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedMoveOp = [OPCODE.move, string | Path, {
    f: string | Path;
}];
export declare class OpMove extends AbstractOp<'move'> {
    readonly from: Path;
    constructor(path: Path, from: Path);
    apply(doc: unknown): {
        doc: unknown;
        old: any;
    };
    toJson(): OperationMove;
    toPacked(): PackedMoveOp;
}
