"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpMove = void 0;
const AbstractOp_1 = require("./AbstractOp");
const OpRemove_1 = require("./OpRemove");
const OpAdd_1 = require("./OpAdd");
const json_pointer_1 = require("../../json-pointer");
class OpMove extends AbstractOp_1.AbstractOp {
    constructor(path, from) {
        super('move', path);
        this.from = from;
    }
    apply(doc) {
        const remove = new OpRemove_1.OpRemove(json_pointer_1.toPath(this.from), undefined).apply(doc);
        const add = new OpAdd_1.OpAdd(this.path, remove.old).apply(remove.doc);
        return add;
    }
    toJson() {
        return {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            from: json_pointer_1.formatJsonPointer(this.from),
        };
    }
    toPacked() {
        const packed = [4, this.path, { f: this.from }];
        return packed;
    }
}
exports.OpMove = OpMove;
