import { AbstractSecondOrderPredicateOp } from './AbstractSecondOrderPredicateOp';
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OperationNot } from '../types';
import { OPCODE } from './constants';
import { PackedOp } from './AbstractOp';
import { Path } from '../../json-pointer';
export declare type PackedNotOp = [OPCODE.not, string | Path, {
    o: PackedOp[];
}];
export declare class OpNot extends AbstractSecondOrderPredicateOp<'not'> {
    readonly ops: AbstractPredicateOp[];
    constructor(path: Path, ops: AbstractPredicateOp[]);
    test(doc: unknown): boolean;
    toJson(): OperationNot;
    toPacked(): PackedNotOp;
}
