"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpNot = void 0;
const AbstractSecondOrderPredicateOp_1 = require("./AbstractSecondOrderPredicateOp");
const json_pointer_1 = require("../../json-pointer");
class OpNot extends AbstractSecondOrderPredicateOp_1.AbstractSecondOrderPredicateOp {
    constructor(path, ops) {
        super('not', path, ops);
        this.ops = ops;
    }
    test(doc) {
        for (const op of this.ops)
            if (op.test(doc))
                return false;
        return true;
    }
    toJson() {
        const op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            apply: this.ops.map((op) => op.toJson()),
        };
        return op;
    }
    toPacked() {
        const packed = [44, this.path, { o: this.ops.map((op) => op.toPacked()) }];
        return packed;
    }
}
exports.OpNot = OpNot;
