import { AbstractSecondOrderPredicateOp } from './AbstractSecondOrderPredicateOp';
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OperationOr } from '../types';
import { OPCODE } from './constants';
import { PackedOp } from './AbstractOp';
import { Path } from '../../json-pointer';
export declare type PackedOrOp = [OPCODE.or, string | Path, {
    o: PackedOp[];
}];
export declare class OpOr extends AbstractSecondOrderPredicateOp<'or'> {
    readonly ops: AbstractPredicateOp[];
    constructor(path: Path, ops: AbstractPredicateOp[]);
    test(doc: unknown): boolean;
    toJson(): OperationOr;
    toPacked(): PackedOrOp;
}
