import { AbstractOp } from './AbstractOp';
import { OperationRemove } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedRemoveOp = [OPCODE.remove, string | Path] | [OPCODE.remove, string | Path, {
    o: unknown;
}];
export declare class OpRemove extends AbstractOp<'remove'> {
    readonly oldValue: unknown;
    constructor(path: Path, oldValue: unknown);
    apply(doc: unknown): {
        doc: unknown;
        old: unknown;
    };
    toJson(): OperationRemove;
    toPacked(): PackedRemoveOp;
}
