import { AbstractOp } from './AbstractOp';
import { OperationReplace } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedReplaceOp = [OPCODE.replace, Path | string, {
    v: unknown;
    o?: unknown;
}];
export declare class OpReplace extends AbstractOp<'replace'> {
    readonly value: unknown;
    readonly oldValue: unknown;
    constructor(path: Path, value: unknown, oldValue: unknown);
    apply(doc: unknown): {
        doc: unknown;
        old: unknown;
    };
    toJson(): OperationReplace;
    toPacked(): PackedReplaceOp;
}
