import { AbstractOp } from './AbstractOp';
import { OperationSplit } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedSplitOp = [OPCODE.split, string | Path, {
    i: number;
    p?: object;
}];
export declare class OpSplit extends AbstractOp<'split'> {
    readonly pos: number;
    readonly props: object | null;
    constructor(path: Path, pos: number, props: object | null);
    apply(doc: unknown): {
        doc: unknown;
        old: unknown;
    };
    private split;
    toJson(): OperationSplit;
    toPacked(): PackedSplitOp;
}
