import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OperationStarts } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedStartsOp = [OPCODE.starts, string | Path, {
    v: string;
    i?: 1;
}];
export declare class OpStarts extends AbstractPredicateOp<'starts'> {
    readonly value: string;
    readonly ignore_case: boolean;
    constructor(path: Path, value: string, ignore_case: boolean);
    test(doc: unknown): boolean;
    toJson(): OperationStarts;
    toPacked(): PackedStartsOp;
}
