import { AbstractOp } from './AbstractOp';
import { OperationStrDel } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedStrDelOp = [OPCODE.str_del, string | Path, {
    i: number;
    s?: string;
    l?: number;
}];
export declare class OpStrDel extends AbstractOp<'str_del'> {
    readonly pos: number;
    readonly str: string | undefined;
    readonly len: number | undefined;
    constructor(path: Path, pos: number, str: string | undefined, len: number | undefined);
    deleteLength(): number;
    apply(doc: unknown): {
        doc: unknown;
        old: string;
    };
    toJson(): OperationStrDel;
    toPacked(): PackedStrDelOp;
}
