import { AbstractOp } from './AbstractOp';
import { OperationStrIns } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedStrInsOp = [OPCODE.str_ins, string | Path, {
    i: number;
    s: string;
}];
export declare class OpStrIns extends AbstractOp<'str_ins'> {
    readonly pos: number;
    readonly str: string;
    constructor(path: Path, pos: number, str: string);
    apply(doc: unknown): {
        doc: unknown;
        old: string | undefined;
    };
    toJson(): OperationStrIns;
    toPacked(): PackedStrInsOp;
}
