"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpTest = void 0;
const json_pointer_1 = require("../../json-pointer");
const AbstractPredicateOp_1 = require("./AbstractPredicateOp");
const isEqual = require('fast-deep-equal');
class OpTest extends AbstractPredicateOp_1.AbstractPredicateOp {
    constructor(path, value, not) {
        super('test', path);
        this.value = value;
        this.not = not;
    }
    test(doc) {
        const { val } = json_pointer_1.find(doc, this.path);
        if (val === undefined)
            return !!this.not;
        const test = isEqual(val, this.value);
        return this.not ? !test : test;
    }
    toJson() {
        const op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
        if (this.not)
            op.not = this.not;
        return op;
    }
    toPacked() {
        const packed = [5, this.path, { v: this.value }];
        if (this.not)
            packed[2].n = 1;
        return packed;
    }
}
exports.OpTest = OpTest;
