import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OperationTestString } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedTestStringOp = [OPCODE.test_string, string | Path, {
    i: number;
    s: string;
    n?: 1;
}];
export declare class OpTestString extends AbstractPredicateOp<'test_string'> {
    readonly pos: number;
    readonly str: string;
    readonly not: boolean;
    constructor(path: Path, pos: number, str: string, not: boolean);
    test(doc: unknown): boolean;
    toJson(): OperationTestString;
    toPacked(): PackedTestStringOp;
}
