import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OperationTestStringLen } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedTestStringLenOp = [OPCODE.test_string_len, string | Path, {
    l: number;
    n?: 1;
}];
export declare class OpTestStringLen extends AbstractPredicateOp<'test_string_len'> {
    readonly len: number;
    readonly not: boolean;
    constructor(path: Path, len: number, not: boolean);
    test(doc: unknown): boolean;
    toJson(): OperationTestStringLen;
    toPacked(): PackedTestStringLenOp;
}
