"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpTestStringLen = void 0;
const AbstractPredicateOp_1 = require("./AbstractPredicateOp");
const json_pointer_1 = require("../../json-pointer");
class OpTestStringLen extends AbstractPredicateOp_1.AbstractPredicateOp {
    constructor(path, len, not) {
        super('test_string_len', path);
        this.len = len;
        this.not = not;
    }
    test(doc) {
        const { val } = json_pointer_1.find(doc, this.path);
        if (typeof val !== 'string')
            return false;
        const length = val.length;
        const test = val.length >= this.len;
        return this.not ? !test : test;
    }
    toJson() {
        const op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            len: this.len,
        };
        if (this.not)
            op.not = this.not;
        return op;
    }
    toPacked() {
        const packed = [41, this.path, { l: this.len }];
        if (this.not)
            packed[2].n = 1;
        return packed;
    }
}
exports.OpTestStringLen = OpTestStringLen;
