import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OperationTestType, JsonPatchTypes } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedTestTypeOp = [OPCODE.test_type, string | Path, {
    t: JsonPatchTypes[];
}];
export declare class OpTestType extends AbstractPredicateOp<'test_type'> {
    readonly type: JsonPatchTypes[];
    constructor(path: Path, type: JsonPatchTypes[]);
    test(doc: unknown): boolean;
    toJson(): OperationTestType;
    toPacked(): PackedTestTypeOp;
}
