"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpTestType = void 0;
const AbstractPredicateOp_1 = require("./AbstractPredicateOp");
const json_pointer_1 = require("../../json-pointer");
const { isArray } = Array;
class OpTestType extends AbstractPredicateOp_1.AbstractPredicateOp {
    constructor(path, type) {
        super('test_type', path);
        this.type = type;
    }
    test(doc) {
        const { val } = json_pointer_1.find(doc, this.path);
        if (val === null)
            return this.type.indexOf('null') > -1;
        if (isArray(val))
            return this.type.indexOf('array') > -1;
        if (this.type.indexOf(typeof val) > -1)
            return true;
        if (typeof val === 'number' && val === Math.round(val) && this.type.indexOf('integer') > -1)
            return true;
        return false;
    }
    toJson() {
        const op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            type: this.type,
        };
        return op;
    }
    toPacked() {
        const packed = [39, this.path, { t: this.type }];
        return packed;
    }
}
exports.OpTestType = OpTestType;
