import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OperationType, JsonPatchTypes } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from './constants';
export declare type PackedTypeOp = [OPCODE.type, string | Path, {
    v: JsonPatchTypes;
}];
export declare class OpType extends AbstractPredicateOp<'type'> {
    readonly value: JsonPatchTypes;
    constructor(path: Path, value: JsonPatchTypes);
    test(doc: unknown): boolean;
    toJson(): OperationType;
    toPacked(): PackedTypeOp;
}
