"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpType = void 0;
const AbstractPredicateOp_1 = require("./AbstractPredicateOp");
const json_pointer_1 = require("../../json-pointer");
const { isArray } = Array;
class OpType extends AbstractPredicateOp_1.AbstractPredicateOp {
    constructor(path, value) {
        super('type', path);
        this.value = value;
    }
    test(doc) {
        const { val } = json_pointer_1.find(doc, this.path);
        if (val === null)
            return this.value === 'null';
        if (isArray(val))
            return this.value === 'array';
        if (typeof val === this.value)
            return true;
        if (typeof val === 'number' && val === Math.round(val) && this.value === 'integer')
            return true;
        return false;
    }
    toJson() {
        const op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
        return op;
    }
    toPacked() {
        const packed = [42, this.path, { v: this.value }];
        return packed;
    }
}
exports.OpType = OpType;
