"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpUndefined = void 0;
const AbstractPredicateOp_1 = require("./AbstractPredicateOp");
const json_pointer_1 = require("../../json-pointer");
class OpUndefined extends AbstractPredicateOp_1.AbstractPredicateOp {
    constructor(path) {
        super('undefined', path);
    }
    test(doc) {
        try {
            const { val } = json_pointer_1.find(doc, this.path);
            const test = val === undefined;
            return test;
        }
        catch (error) {
            if (error.message === 'NOT_FOUND')
                return true;
            throw error;
        }
    }
    toJson() {
        const op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
        };
        return op;
    }
    toPacked() {
        const packed = [38, this.path];
        return packed;
    }
}
exports.OpUndefined = OpUndefined;
