"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isElementNode = exports.isTextNode = exports.deepClone = void 0;
const { isArray } = Array;
const objectKeys = Object.keys;
function deepClone(obj) {
    if (!obj)
        return obj;
    if (isArray(obj)) {
        const arr = [];
        const length = obj.length;
        for (let i = 0; i < length; i++)
            arr.push(deepClone(obj[i]));
        return arr;
    }
    else if (typeof obj === 'object') {
        const keys = objectKeys(obj);
        const length = keys.length;
        const newObject = {};
        for (let i = 0; i < length; i++) {
            const key = keys[i];
            newObject[key] = deepClone(obj[key]);
        }
        return newObject;
    }
    return obj;
}
exports.deepClone = deepClone;
const isTextNode = (node) => !!node && typeof node === 'object' && typeof node.text === 'string';
exports.isTextNode = isTextNode;
const isElementNode = (node) => !!node && typeof node === 'object' && isArray(node.children);
exports.isElementNode = isElementNode;
