import { JsonRpcRxServerParams } from '../json-rx/JsonRpcRxServer';
export interface RpcMessageRequest {
    jsonrpc?: "2.0";
    id: number | string | null;
    method: string;
    params: unknown;
}
export interface RpcMessageResponse {
    jsonrpc?: "2.0";
    id: number | string | null;
    result: unknown;
}
export interface RpcMessageError {
    jsonrpc?: "2.0";
    id: number | string | null;
    error: RpcError;
}
export interface RpcError {
    code: number;
    message: string;
    data?: unknown;
}
export interface RpcMessageNotification {
    jsonrpc?: "2.0";
    method: string;
    params: unknown;
}
export interface JsonRpcServerParams<Context> extends JsonRpcRxServerParams<Context> {
    strict?: boolean;
}
export declare class JsonRpcServer<Context = unknown> {
    private readonly rx;
    private readonly strict;
    constructor(params: JsonRpcServerParams<Context>);
    private formatError;
    onMessage(ctx: Context, message: RpcMessageRequest | RpcMessageNotification): Promise<null | RpcMessageResponse | RpcMessageError>;
}
