import { MessageError, MessageComplete, MessageOrMessageBatch } from './types';
declare type Call<Context> = (name: string, ctx: Context, payload?: unknown) => Promise<unknown>;
declare type Notify<Context> = (name: string, ctx: Context, payload?: unknown) => void;
export interface JsonRpcRxServerParams<Context> {
    call: Call<Context>;
    notify: Notify<Context>;
}
export declare class JsonRpcRxServer<Context = unknown> {
    private call;
    private notify;
    constructor({ call, notify }: JsonRpcRxServerParams<Context>);
    private onSubscribe;
    private onNotification;
    onMessage(ctx: Context, message: MessageOrMessageBatch): Promise<MessageOrMessageBatch<MessageComplete | MessageError> | null>;
}
export {};
