import { MessageSubscribe, MessageError, MessageData, MessageComplete, MessageNotification, MessageUnsubscribe, MessageOrMessageBatch } from './types';
import { Observable } from 'rxjs';
declare type IncomingMessage = MessageOrMessageBatch<MessageData | MessageComplete | MessageError>;
declare type OutgoingMessage = MessageOrMessageBatch<MessageSubscribe | MessageUnsubscribe | MessageNotification>;
export interface JsonRxClientParams {
    send: (message: OutgoingMessage) => void;
    bufferSize?: number;
    bufferTime?: number;
}
export declare class JsonRxClient {
    private cnt;
    private readonly buffer;
    private readonly observers;
    constructor({ send, bufferSize, bufferTime }: JsonRxClientParams);
    private sendSubscribe;
    private sendUnsubscribe;
    private onData;
    private onComplete;
    private onError;
    onMessage(message: IncomingMessage): void;
    call(method: string, payload: unknown): Observable<unknown>;
    notify(name: string, payload?: unknown): void;
    stop(): void;
}
export {};
