import { json_string } from 'ts-brand-json';
import { MessageSubscribe, MessageError, MessageData, MessageNotification, MessageUnsubscribe, MessageComplete, MessageOrMessageBatch } from './types';
import { Observable } from 'rxjs';
declare type IncomingMessage = MessageOrMessageBatch<MessageSubscribe | MessageUnsubscribe | MessageNotification>;
declare type OutgoingMessage = MessageOrMessageBatch<MessageData | MessageComplete | MessageError>;
export interface JsonRxServerParams<Ctx = unknown> {
    send: (message: json_string<OutgoingMessage>) => void;
    call: (name: string, payload: unknown, ctx: Ctx) => Promise<json_string<unknown>> | Observable<json_string<unknown>> | Promise<Observable<json_string<unknown>>>;
    notify: (name: string, payload: unknown, ctx: Ctx) => void;
    maxActiveSubscriptions?: number;
    bufferSize?: number;
    bufferTime?: number;
}
export declare class JsonRxServer<Ctx = unknown> {
    private send;
    private call;
    private notify;
    private readonly active;
    private readonly maxActiveSubscriptions;
    constructor({ send, call, notify, maxActiveSubscriptions, bufferSize, bufferTime }: JsonRxServerParams<Ctx>);
    private sendError;
    private onSubscribe;
    private onUnsubscribe;
    private onNotification;
    onMessage(message: IncomingMessage, ctx: Ctx): void;
    stop(): void;
}
export {};
