import { Observable } from 'rxjs';
export declare type Method = (payload: unknown) => Observable<unknown>;
export declare type Id = number;
export declare type Name = string;
export declare type MessageSubscribe = [Id, Name, unknown] | [Id, Name];
export declare type MessageComplete = [0, Id, unknown] | [0, Id];
export declare type MessageError = [-1, Id, unknown];
export declare type MessageNotification = [Name, unknown] | [Name];
export declare type MessageData = [-2, Id, unknown];
export declare type MessageUnsubscribe = [-3, Id];
export declare type Message = MessageSubscribe | MessageUnsubscribe | MessageData | MessageUnsubscribe | MessageError | MessageNotification;
export declare type MessageBatch<M = Message> = M[];
export declare type MessageOrMessageBatch<M = Message> = M | MessageBatch<M>;
