"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.microtask = exports.assertName = exports.assertId = exports.isArray = void 0;
exports.isArray = Array.isArray;
const assertId = (id) => {
    if (typeof id !== 'number' || id < 1 || Math.round(id) !== id)
        throw new Error('Invalid ID.');
};
exports.assertId = assertId;
const assertName = (name) => {
    if (typeof name !== 'string' || !name || name.length > 128)
        throw new Error('Invalid method.');
};
exports.assertName = assertName;
const nextTickMicrotask = typeof process === 'object' && typeof process.nextTick === 'function' ? process.nextTick : null;
const promiseMicrotask = (callback) => {
    Promise.resolve().then(callback);
};
exports.microtask = nextTickMicrotask || promiseMicrotask;
