import { deepClone } from '../util';
import { operationToOp } from '../op';
export function applyOp(doc, op, mutate) {
    if (!mutate)
        doc = deepClone(doc);
    return op.apply(doc);
}
export function applyOps(doc, ops, mutate) {
    if (!mutate)
        doc = deepClone(doc);
    const res = [];
    const length = ops.length;
    for (let i = 0; i < length; i++) {
        const opResult = ops[i].apply(doc);
        doc = opResult.doc;
        res.push(opResult);
    }
    return { doc, res };
}
export function applyPatch(doc, patch, mutate) {
    const result = applyOps(doc, patch.map(operationToOp), mutate);
    return result;
}
