import { AbstractSecondOrderPredicateOp } from './AbstractSecondOrderPredicateOp';
import { formatJsonPointer } from '../../json-pointer';
export class OpAnd extends AbstractSecondOrderPredicateOp {
    constructor(path, ops) {
        super('and', path, ops);
        this.ops = ops;
    }
    test(doc) {
        for (const op of this.ops)
            if (!op.test(doc))
                return false;
        return true;
    }
    toJson() {
        const op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            apply: this.ops.map((op) => op.toJson()),
        };
        return op;
    }
    toPacked() {
        return [43, this.path, { o: this.ops.map((op) => op.toPacked()) }];
    }
}
