import { AbstractOp } from './AbstractOp';
import { find, formatJsonPointer } from '../../json-pointer';
import { OpAdd } from './OpAdd';
import { deepClone } from '../util';
export class OpCopy extends AbstractOp {
    constructor(path, from) {
        super('copy', path);
        this.from = from;
    }
    apply(doc) {
        const { val } = find(doc, this.from);
        if (val === undefined)
            throw new Error('NOT_FOUND');
        const add = new OpAdd(this.path, deepClone(val)).apply(doc);
        return add;
    }
    toJson() {
        return {
            op: this.op,
            path: formatJsonPointer(this.path),
            from: formatJsonPointer(this.from),
        };
    }
    toPacked() {
        const packed = [3, this.path, { f: this.from }];
        return packed;
    }
}
