import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
export class OpDefined extends AbstractPredicateOp {
    constructor(path) {
        super('defined', path);
    }
    test(doc) {
        const { val } = find(doc, this.path);
        const test = val !== undefined;
        return test;
    }
    toJson() {
        const op = {
            op: this.op,
            path: formatJsonPointer(this.path),
        };
        return op;
    }
    toPacked() {
        const packed = [31, this.path];
        return packed;
    }
}
