import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
export class OpEnds extends AbstractPredicateOp {
    constructor(path, value, ignore_case) {
        super('ends', path);
        this.value = value;
        this.ignore_case = ignore_case;
    }
    test(doc) {
        const { val } = find(doc, this.path);
        if (typeof val !== 'string')
            return false;
        const outer = this.ignore_case ? val.toLowerCase() : val;
        const inner = this.ignore_case ? this.value.toLowerCase() : this.value;
        const test = outer.endsWith(inner);
        return test;
    }
    toJson() {
        const op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            value: this.value,
        };
        if (this.ignore_case)
            op.ignore_case = this.ignore_case;
        return op;
    }
    toPacked() {
        const packed = [32, this.path, { v: this.value }];
        if (this.ignore_case)
            packed[2].i = 1;
        return packed;
    }
}
