import { AbstractOp } from './AbstractOp';
import { find, formatJsonPointer } from '../../json-pointer';
export class OpFlip extends AbstractOp {
    constructor(path) {
        super('flip', path);
    }
    apply(doc) {
        const ref = find(doc, this.path);
        if (ref.obj)
            ref.obj[ref.key] = !ref.val;
        else
            doc = !ref.val;
        return { doc, old: ref.val };
    }
    toJson() {
        const op = {
            op: this.op,
            path: formatJsonPointer(this.path),
        };
        return op;
    }
    toPacked() {
        const packed = [8, this.path];
        return packed;
    }
}
