import { find, formatJsonPointer } from '../../json-pointer';
import { AbstractPredicateOp } from './AbstractPredicateOp';
const isEqual = require('fast-deep-equal');
export class OpIn extends AbstractPredicateOp {
    constructor(path, value) {
        super('in', path);
        this.value = value;
    }
    test(doc) {
        const { val } = find(doc, this.path);
        for (const x of this.value)
            if (isEqual(val, x))
                return true;
        return false;
    }
    toJson() {
        const op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            value: this.value,
        };
        return op;
    }
    toPacked() {
        const packed = [33, this.path, { v: this.value }];
        return packed;
    }
}
