import { AbstractOp } from './AbstractOp';
import { find, formatJsonPointer } from '../../json-pointer';
export class OpInc extends AbstractOp {
    constructor(path, inc) {
        super('inc', path);
        this.inc = inc;
    }
    apply(doc) {
        const ref = find(doc, this.path);
        const result = this.inc + Number(ref.val);
        if (ref.obj)
            ref.obj[ref.key] = result;
        else
            doc = result;
        return { doc, old: ref.val };
    }
    toJson() {
        const op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            inc: this.inc,
        };
        return op;
    }
    toPacked() {
        const packed = [9, this.path, { v: this.inc }];
        return packed;
    }
}
