import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
export class OpLess extends AbstractPredicateOp {
    constructor(path, value) {
        super('less', path);
        this.value = value;
    }
    test(doc) {
        const { val } = find(doc, this.path);
        if (typeof val !== 'number')
            return false;
        const test = val < this.value;
        return test;
    }
    toJson() {
        const op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            value: this.value,
        };
        return op;
    }
    toPacked() {
        const packed = [34, this.path, { v: this.value }];
        return packed;
    }
}
