import { AbstractOp } from './AbstractOp';
import { OpRemove } from './OpRemove';
import { OpAdd } from './OpAdd';
import { toPath, formatJsonPointer } from '../../json-pointer';
export class OpMove extends AbstractOp {
    constructor(path, from) {
        super('move', path);
        this.from = from;
    }
    apply(doc) {
        const remove = new OpRemove(toPath(this.from), undefined).apply(doc);
        const add = new OpAdd(this.path, remove.old).apply(remove.doc);
        return add;
    }
    toJson() {
        return {
            op: this.op,
            path: formatJsonPointer(this.path),
            from: formatJsonPointer(this.from),
        };
    }
    toPacked() {
        const packed = [4, this.path, { f: this.from }];
        return packed;
    }
}
