import { AbstractSecondOrderPredicateOp } from './AbstractSecondOrderPredicateOp';
import { formatJsonPointer } from '../../json-pointer';
export class OpOr extends AbstractSecondOrderPredicateOp {
    constructor(path, ops) {
        super('or', path, ops);
        this.ops = ops;
    }
    test(doc) {
        for (const op of this.ops)
            if (op.test(doc))
                return true;
        return false;
    }
    toJson() {
        const op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            apply: this.ops.map((op) => op.toJson()),
        };
        return op;
    }
    toPacked() {
        const packed = [45, this.path, { o: this.ops.map((op) => op.toPacked()) }];
        return packed;
    }
}
