import { find, formatJsonPointer } from '../../json-pointer';
import { AbstractPredicateOp } from './AbstractPredicateOp';
const isEqual = require('fast-deep-equal');
export class OpTest extends AbstractPredicateOp {
    constructor(path, value, not) {
        super('test', path);
        this.value = value;
        this.not = not;
    }
    test(doc) {
        const { val } = find(doc, this.path);
        if (val === undefined)
            return !!this.not;
        const test = isEqual(val, this.value);
        return this.not ? !test : test;
    }
    toJson() {
        const op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            value: this.value,
        };
        if (this.not)
            op.not = this.not;
        return op;
    }
    toPacked() {
        const packed = [5, this.path, { v: this.value }];
        if (this.not)
            packed[2].n = 1;
        return packed;
    }
}
