import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
export class OpTestStringLen extends AbstractPredicateOp {
    constructor(path, len, not) {
        super('test_string_len', path);
        this.len = len;
        this.not = not;
    }
    test(doc) {
        const { val } = find(doc, this.path);
        if (typeof val !== 'string')
            return false;
        const length = val.length;
        const test = val.length >= this.len;
        return this.not ? !test : test;
    }
    toJson() {
        const op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            len: this.len,
        };
        if (this.not)
            op.not = this.not;
        return op;
    }
    toPacked() {
        const packed = [41, this.path, { l: this.len }];
        if (this.not)
            packed[2].n = 1;
        return packed;
    }
}
