import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
const { isArray } = Array;
export class OpTestType extends AbstractPredicateOp {
    constructor(path, type) {
        super('test_type', path);
        this.type = type;
    }
    test(doc) {
        const { val } = find(doc, this.path);
        if (val === null)
            return this.type.indexOf('null') > -1;
        if (isArray(val))
            return this.type.indexOf('array') > -1;
        if (this.type.indexOf(typeof val) > -1)
            return true;
        if (typeof val === 'number' && val === Math.round(val) && this.type.indexOf('integer') > -1)
            return true;
        return false;
    }
    toJson() {
        const op = {
            op: this.op,
            path: formatJsonPointer(this.path),
            type: this.type,
        };
        return op;
    }
    toPacked() {
        const packed = [39, this.path, { t: this.type }];
        return packed;
    }
}
