import { AbstractPredicateOp } from './AbstractPredicateOp';
import { find, formatJsonPointer } from '../../json-pointer';
export class OpUndefined extends AbstractPredicateOp {
    constructor(path) {
        super('undefined', path);
    }
    test(doc) {
        try {
            const { val } = find(doc, this.path);
            const test = val === undefined;
            return test;
        }
        catch (error) {
            if (error.message === 'NOT_FOUND')
                return true;
            throw error;
        }
    }
    toJson() {
        const op = {
            op: this.op,
            path: formatJsonPointer(this.path),
        };
        return op;
    }
    toPacked() {
        const packed = [38, this.path];
        return packed;
    }
}
