export const { isArray } = Array;
export const assertId = (id) => {
    if (typeof id !== 'number' || id < 1 || Math.round(id) !== id)
        throw new Error('Invalid ID.');
};
export const assertName = (name) => {
    if (typeof name !== 'string' || !name || name.length > 128)
        throw new Error('Invalid method.');
};
const nextTickMicrotask = typeof process === 'object' && typeof process.nextTick === 'function' ? process.nextTick : null;
const promiseMicrotask = (callback) => {
    Promise.resolve().then(callback);
};
export const microtask = nextTickMicrotask || promiseMicrotask;
