"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var json_patch_1 = require("../json-patch");
var patch_1 = require("../json-patch/patch");
try {
    var buf = fs_1.readFileSync(0);
    var doc = JSON.parse(buf.toString());
    var patch = JSON.parse(process.argv[2]);
    patch.forEach(json_patch_1.validateOperation);
    var res = patch_1.applyPatch(doc, patch, true);
    process.stdout.write(JSON.stringify(res.doc, null, 4) + '\n');
}
catch (error) {
    var output = error instanceof Error ? error.message : String(error);
    process.stderr.write(output + '\n');
    process.exit(1);
}
