"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var json_pointer_1 = require("../json-pointer");
try {
    var buf = fs_1.readFileSync(0);
    var doc = JSON.parse(buf.toString());
    var result = json_pointer_1.findByPointer(process.argv[2], doc);
    var value = result.val;
    if (value === undefined) {
        if (Array.isArray(result.obj))
            throw 'INVALID_INDEX';
        throw 'NOT_FOUND';
    }
    process.stdout.write(JSON.stringify(value, null, 4) + '\n');
}
catch (error) {
    process.stderr.write(error + '\n');
    process.exit(1);
}
