"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transform = void 0;
var tslib_1 = require("tslib");
var transforms_1 = require("./transforms");
var transform = function (accepted, proposed) {
    var e_1, _a;
    var length = accepted.length;
    for (var i = 0; i < length; i++) {
        var against = accepted[i];
        var transformFunction = transforms_1.xforms[against.op];
        if (transformFunction) {
            var transformed = [];
            try {
                for (var proposed_1 = (e_1 = void 0, tslib_1.__values(proposed)), proposed_1_1 = proposed_1.next(); !proposed_1_1.done; proposed_1_1 = proposed_1.next()) {
                    var op = proposed_1_1.value;
                    var newOps = transformFunction(against, op);
                    if (Array.isArray(newOps))
                        transformed.push.apply(transformed, tslib_1.__spread(newOps));
                    else if (newOps)
                        transformed.push(newOps);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (proposed_1_1 && !proposed_1_1.done && (_a = proposed_1.return)) _a.call(proposed_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            proposed = transformed;
        }
    }
    return proposed;
};
exports.transform = transform;
