"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lowerArrayPath = exports.bumpArrayPath = void 0;
var tslib_1 = require("tslib");
var json_pointer_1 = require("../../json-pointer");
var bumpArrayPath = function (path1, path2) {
    var folder = json_pointer_1.parent(path1);
    var lastIndex = path1.length - 1;
    var step1 = path1[lastIndex];
    if (json_pointer_1.isChild(folder, path2)) {
        var step2 = path2[lastIndex];
        if (json_pointer_1.isValidIndex(step2)) {
            var index1 = Number(step1);
            var index2 = Number(step2);
            if (index1 <= index2) {
                var steps = tslib_1.__spread(path2);
                steps[lastIndex] = String(index2 + 1);
                return steps;
            }
        }
    }
    return undefined;
};
exports.bumpArrayPath = bumpArrayPath;
var lowerArrayPath = function (path1, path2) {
    var folder = json_pointer_1.parent(path1);
    var lastIndex = path1.length - 1;
    var step1 = path1[lastIndex];
    if (json_pointer_1.isChild(folder, path2)) {
        var step2 = path2[lastIndex];
        if (json_pointer_1.isValidIndex(step2)) {
            var index1 = Number(step1);
            var index2 = Number(step2);
            if (index1 < index2) {
                var steps = tslib_1.__spread(path2);
                steps[lastIndex] = String(index2 - 1);
                return steps;
            }
        }
    }
    return undefined;
};
exports.lowerArrayPath = lowerArrayPath;
