"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.xAdd = void 0;
var tslib_1 = require("tslib");
var op_1 = require("../../json-patch/op");
var json_pointer_1 = require("../../json-pointer");
var util_1 = require("./util");
var xAdd = function (add, op) {
    if (json_pointer_1.isRoot(add.path))
        return null;
    if (json_pointer_1.isRoot(op.path))
        return op;
    var lastIndex = add.path.length - 1;
    var lastStep = add.path[lastIndex];
    var isLastStepNumberLike = json_pointer_1.isValidIndex(lastStep);
    if (json_pointer_1.isChild(add.path, op.path) && !isLastStepNumberLike)
        return null;
    if (isLastStepNumberLike) {
        var newPath = util_1.bumpArrayPath(add.path, op.path);
        var newFrom = op.from ? util_1.bumpArrayPath(add.path, op.from) : undefined;
        if (newPath || newFrom) {
            var operation = tslib_1.__assign(tslib_1.__assign({}, op.toJson()), { path: newPath ? json_pointer_1.formatJsonPointer(newPath) : op.path });
            if (newFrom)
                operation.from = json_pointer_1.formatJsonPointer(newFrom);
            return op_1.operationToOp(operation);
        }
    }
    return op;
};
exports.xAdd = xAdd;
