"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyPatch = void 0;
var tslib_1 = require("tslib");
var util_1 = require("../util");
var v6_1 = require("../../json-pointer/findByPointer/v6");
function applyOp(doc, operation) {
    switch (operation.op) {
        case 'add': {
            var _a = tslib_1.__read(v6_1.findByPointer(operation.path, doc), 2), obj = _a[0], key = _a[1];
            switch (typeof key) {
                case 'number': {
                    if (key > obj.length)
                        throw new Error('INVALID_INDEX');
                    if (key === obj.length)
                        obj.push(operation.value);
                    else
                        obj.splice(key, 0, operation.value);
                    break;
                }
                case 'string': {
                    obj[key] = operation.value;
                    break;
                }
                default: {
                    doc = operation.value;
                    break;
                }
            }
        }
    }
    return { doc: doc };
}
function applyPatch(doc, patch, mutate) {
    if (!mutate)
        doc = util_1.deepClone(doc);
    var res = [];
    for (var i = 0; i < patch.length; i++) {
        var operation = patch[i];
        var operationResult = applyOp(doc, operation);
        res.push(operationResult);
        doc = operationResult.doc;
    }
    return { doc: doc, res: res };
}
exports.applyPatch = applyPatch;
