"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyPatch = exports.applyOps = exports.applyOp = void 0;
var util_1 = require("../util");
var op_1 = require("../op");
function applyOp(doc, op, mutate) {
    if (!mutate)
        doc = util_1.deepClone(doc);
    return op.apply(doc);
}
exports.applyOp = applyOp;
function applyOps(doc, ops, mutate) {
    if (!mutate)
        doc = util_1.deepClone(doc);
    var res = [];
    var length = ops.length;
    for (var i = 0; i < length; i++) {
        var opResult = ops[i].apply(doc);
        doc = opResult.doc;
        res.push(opResult);
    }
    return { doc: doc, res: res };
}
exports.applyOps = applyOps;
function applyPatch(doc, patch, mutate) {
    if (!mutate)
        doc = util_1.deepClone(doc);
    var res = [];
    var length = patch.length;
    for (var i = 0; i < length; i++) {
        var op = op_1.operationToOp(patch[i]);
        var opResult = op.apply(doc);
        doc = opResult.doc;
        res.push(opResult);
    }
    return { doc: doc, res: res };
}
exports.applyPatch = applyPatch;
