"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpAdd = void 0;
var tslib_1 = require("tslib");
var AbstractOp_1 = require("./AbstractOp");
var json_pointer_1 = require("../../json-pointer");
var OpAdd = (function (_super) {
    tslib_1.__extends(OpAdd, _super);
    function OpAdd(path, value) {
        var _this = _super.call(this, 'add', path) || this;
        _this.value = value;
        return _this;
    }
    OpAdd.prototype.apply = function (doc) {
        var _a = json_pointer_1.find(doc, this.path), val = _a.val, key = _a.key, obj = _a.obj;
        var value = this.value;
        if (!obj)
            doc = value;
        else if (typeof key === 'string')
            obj[key] = value;
        else {
            var length_1 = obj.length;
            if (key < length_1)
                obj.splice(key, 0, this.value);
            else if (key > length_1)
                throw new Error('INVALID_INDEX');
            else
                obj.push(this.value);
        }
        return { doc: doc, old: val };
    };
    OpAdd.prototype.toJson = function () {
        return {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
    };
    OpAdd.prototype.toPacked = function () {
        return [0, this.path, { v: this.value }];
    };
    return OpAdd;
}(AbstractOp_1.AbstractOp));
exports.OpAdd = OpAdd;
