"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpContains = void 0;
var tslib_1 = require("tslib");
var AbstractPredicateOp_1 = require("./AbstractPredicateOp");
var json_pointer_1 = require("../../json-pointer");
var OpContains = (function (_super) {
    tslib_1.__extends(OpContains, _super);
    function OpContains(path, value, ignore_case) {
        var _this = _super.call(this, 'contains', path) || this;
        _this.value = value;
        _this.ignore_case = ignore_case;
        return _this;
    }
    OpContains.prototype.test = function (doc) {
        var val = json_pointer_1.find(doc, this.path).val;
        if (typeof val !== 'string')
            return false;
        var testValue = this.ignore_case ? val.toLowerCase() : val;
        var testString = this.ignore_case ? this.value.toLowerCase() : this.value;
        var test = testValue.indexOf(testString) > -1;
        return test;
    };
    OpContains.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
        if (this.ignore_case)
            op.ignore_case = this.ignore_case;
        return op;
    };
    OpContains.prototype.toPacked = function () {
        var packed = [30, this.path, { v: this.value }];
        if (this.ignore_case)
            packed[2].i = 1;
        return packed;
    };
    return OpContains;
}(AbstractPredicateOp_1.AbstractPredicateOp));
exports.OpContains = OpContains;
