"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpCopy = void 0;
var tslib_1 = require("tslib");
var AbstractOp_1 = require("./AbstractOp");
var json_pointer_1 = require("../../json-pointer");
var OpAdd_1 = require("./OpAdd");
var util_1 = require("../util");
var OpCopy = (function (_super) {
    tslib_1.__extends(OpCopy, _super);
    function OpCopy(path, from) {
        var _this = _super.call(this, 'copy', path) || this;
        _this.from = from;
        return _this;
    }
    OpCopy.prototype.apply = function (doc) {
        var val = json_pointer_1.find(doc, this.from).val;
        if (val === undefined)
            throw new Error('NOT_FOUND');
        var add = new OpAdd_1.OpAdd(this.path, util_1.deepClone(val)).apply(doc);
        return add;
    };
    OpCopy.prototype.toJson = function () {
        return {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            from: json_pointer_1.formatJsonPointer(this.from),
        };
    };
    OpCopy.prototype.toPacked = function () {
        var packed = [3, this.path, { f: this.from }];
        return packed;
    };
    return OpCopy;
}(AbstractOp_1.AbstractOp));
exports.OpCopy = OpCopy;
