"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpFlip = void 0;
var tslib_1 = require("tslib");
var AbstractOp_1 = require("./AbstractOp");
var json_pointer_1 = require("../../json-pointer");
var OpFlip = (function (_super) {
    tslib_1.__extends(OpFlip, _super);
    function OpFlip(path) {
        return _super.call(this, 'flip', path) || this;
    }
    OpFlip.prototype.apply = function (doc) {
        var ref = json_pointer_1.find(doc, this.path);
        if (ref.obj)
            ref.obj[ref.key] = !ref.val;
        else
            doc = !ref.val;
        return { doc: doc, old: ref.val };
    };
    OpFlip.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
        };
        return op;
    };
    OpFlip.prototype.toPacked = function () {
        var packed = [8, this.path];
        return packed;
    };
    return OpFlip;
}(AbstractOp_1.AbstractOp));
exports.OpFlip = OpFlip;
