"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpIn = void 0;
var tslib_1 = require("tslib");
var json_pointer_1 = require("../../json-pointer");
var AbstractPredicateOp_1 = require("./AbstractPredicateOp");
var isEqual = require('fast-deep-equal');
var OpIn = (function (_super) {
    tslib_1.__extends(OpIn, _super);
    function OpIn(path, value) {
        var _this = _super.call(this, 'in', path) || this;
        _this.value = value;
        return _this;
    }
    OpIn.prototype.test = function (doc) {
        var e_1, _a;
        var val = json_pointer_1.find(doc, this.path).val;
        try {
            for (var _b = tslib_1.__values(this.value), _c = _b.next(); !_c.done; _c = _b.next()) {
                var x = _c.value;
                if (isEqual(val, x))
                    return true;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return false;
    };
    OpIn.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
        return op;
    };
    OpIn.prototype.toPacked = function () {
        var packed = [33, this.path, { v: this.value }];
        return packed;
    };
    return OpIn;
}(AbstractPredicateOp_1.AbstractPredicateOp));
exports.OpIn = OpIn;
