"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpInc = void 0;
var tslib_1 = require("tslib");
var AbstractOp_1 = require("./AbstractOp");
var json_pointer_1 = require("../../json-pointer");
var OpInc = (function (_super) {
    tslib_1.__extends(OpInc, _super);
    function OpInc(path, inc) {
        var _this = _super.call(this, 'inc', path) || this;
        _this.inc = inc;
        return _this;
    }
    OpInc.prototype.apply = function (doc) {
        var ref = json_pointer_1.find(doc, this.path);
        var result = this.inc + Number(ref.val);
        if (ref.obj)
            ref.obj[ref.key] = result;
        else
            doc = result;
        return { doc: doc, old: ref.val };
    };
    OpInc.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            inc: this.inc,
        };
        return op;
    };
    OpInc.prototype.toPacked = function () {
        var packed = [9, this.path, { v: this.inc }];
        return packed;
    };
    return OpInc;
}(AbstractOp_1.AbstractOp));
exports.OpInc = OpInc;
