"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpMatches = void 0;
var tslib_1 = require("tslib");
var AbstractPredicateOp_1 = require("./AbstractPredicateOp");
var json_pointer_1 = require("../../json-pointer");
var OpMatches = (function (_super) {
    tslib_1.__extends(OpMatches, _super);
    function OpMatches(path, value, ignore_case) {
        var _this = _super.call(this, 'matches', path) || this;
        _this.value = value;
        _this.ignore_case = ignore_case;
        return _this;
    }
    OpMatches.prototype.test = function (doc) {
        var val = json_pointer_1.find(doc, this.path).val;
        if (typeof val !== 'string')
            return false;
        var reg = new RegExp(this.value, this.ignore_case ? 'i' : undefined);
        var test = reg.test(val);
        return test;
    };
    OpMatches.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
        if (this.ignore_case)
            op.ignore_case = this.ignore_case;
        return op;
    };
    OpMatches.prototype.toPacked = function () {
        var packed = [35, this.path, { v: this.value }];
        if (this.ignore_case)
            packed[2].i = 1;
        return packed;
    };
    return OpMatches;
}(AbstractPredicateOp_1.AbstractPredicateOp));
exports.OpMatches = OpMatches;
