"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpMore = void 0;
var tslib_1 = require("tslib");
var AbstractPredicateOp_1 = require("./AbstractPredicateOp");
var json_pointer_1 = require("../../json-pointer");
var OpMore = (function (_super) {
    tslib_1.__extends(OpMore, _super);
    function OpMore(path, value) {
        var _this = _super.call(this, 'more', path) || this;
        _this.value = value;
        return _this;
    }
    OpMore.prototype.test = function (doc) {
        var val = json_pointer_1.find(doc, this.path).val;
        if (typeof val !== 'number')
            return false;
        var test = val > this.value;
        return test;
    };
    OpMore.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
        return op;
    };
    OpMore.prototype.toPacked = function () {
        var packed = [36, this.path, { v: this.value }];
        return packed;
    };
    return OpMore;
}(AbstractPredicateOp_1.AbstractPredicateOp));
exports.OpMore = OpMore;
