"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpMove = void 0;
var tslib_1 = require("tslib");
var AbstractOp_1 = require("./AbstractOp");
var OpRemove_1 = require("./OpRemove");
var OpAdd_1 = require("./OpAdd");
var json_pointer_1 = require("../../json-pointer");
var OpMove = (function (_super) {
    tslib_1.__extends(OpMove, _super);
    function OpMove(path, from) {
        var _this = _super.call(this, 'move', path) || this;
        _this.from = from;
        return _this;
    }
    OpMove.prototype.apply = function (doc) {
        var remove = new OpRemove_1.OpRemove(json_pointer_1.toPath(this.from), undefined).apply(doc);
        var add = new OpAdd_1.OpAdd(this.path, remove.old).apply(remove.doc);
        return add;
    };
    OpMove.prototype.toJson = function () {
        return {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            from: json_pointer_1.formatJsonPointer(this.from),
        };
    };
    OpMove.prototype.toPacked = function () {
        var packed = [4, this.path, { f: this.from }];
        return packed;
    };
    return OpMove;
}(AbstractOp_1.AbstractOp));
exports.OpMove = OpMove;
