"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpOr = void 0;
var tslib_1 = require("tslib");
var AbstractSecondOrderPredicateOp_1 = require("./AbstractSecondOrderPredicateOp");
var json_pointer_1 = require("../../json-pointer");
var OpOr = (function (_super) {
    tslib_1.__extends(OpOr, _super);
    function OpOr(path, ops) {
        var _this = _super.call(this, 'or', path, ops) || this;
        _this.ops = ops;
        return _this;
    }
    OpOr.prototype.test = function (doc) {
        var e_1, _a;
        try {
            for (var _b = tslib_1.__values(this.ops), _c = _b.next(); !_c.done; _c = _b.next()) {
                var op = _c.value;
                if (op.test(doc))
                    return true;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return false;
    };
    OpOr.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            apply: this.ops.map(function (op) { return op.toJson(); }),
        };
        return op;
    };
    OpOr.prototype.toPacked = function () {
        var packed = [45, this.path, { o: this.ops.map(function (op) { return op.toPacked(); }) }];
        return packed;
    };
    return OpOr;
}(AbstractSecondOrderPredicateOp_1.AbstractSecondOrderPredicateOp));
exports.OpOr = OpOr;
