"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpReplace = void 0;
var tslib_1 = require("tslib");
var AbstractOp_1 = require("./AbstractOp");
var json_pointer_1 = require("../../json-pointer");
var OpReplace = (function (_super) {
    tslib_1.__extends(OpReplace, _super);
    function OpReplace(path, value, oldValue) {
        var _this = _super.call(this, 'replace', path) || this;
        _this.value = value;
        _this.oldValue = oldValue;
        return _this;
    }
    OpReplace.prototype.apply = function (doc) {
        var ref = json_pointer_1.find(doc, this.path);
        if (ref.val === undefined)
            throw new Error('NOT_FOUND');
        if (json_pointer_1.isObjectReference(ref))
            ref.obj[ref.key] = this.value;
        else if (json_pointer_1.isArrayReference(ref))
            ref.obj[ref.key] = this.value;
        else
            doc = this.value;
        return { doc: doc, old: ref.val };
    };
    OpReplace.prototype.toJson = function () {
        var json = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
        if (this.oldValue !== undefined)
            json.oldValue = this.oldValue;
        return json;
    };
    OpReplace.prototype.toPacked = function () {
        var packed = [2, this.path, { v: this.value }];
        if (this.oldValue !== undefined)
            packed[2].o = this.oldValue;
        return packed;
    };
    return OpReplace;
}(AbstractOp_1.AbstractOp));
exports.OpReplace = OpReplace;
