"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpStarts = void 0;
var tslib_1 = require("tslib");
var AbstractPredicateOp_1 = require("./AbstractPredicateOp");
var json_pointer_1 = require("../../json-pointer");
var OpStarts = (function (_super) {
    tslib_1.__extends(OpStarts, _super);
    function OpStarts(path, value, ignore_case) {
        var _this = _super.call(this, 'starts', path) || this;
        _this.value = value;
        _this.ignore_case = ignore_case;
        return _this;
    }
    OpStarts.prototype.test = function (doc) {
        var val = json_pointer_1.find(doc, this.path).val;
        if (typeof val !== 'string')
            return false;
        var outer = this.ignore_case ? val.toLowerCase() : val;
        var inner = this.ignore_case ? this.value.toLowerCase() : this.value;
        var test = outer.startsWith(inner);
        return test;
    };
    OpStarts.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
        if (this.ignore_case)
            op.ignore_case = this.ignore_case;
        return op;
    };
    OpStarts.prototype.toPacked = function () {
        var packed = [37, this.path, { v: this.value }];
        if (this.ignore_case)
            packed[2].i = 1;
        return packed;
    };
    return OpStarts;
}(AbstractPredicateOp_1.AbstractPredicateOp));
exports.OpStarts = OpStarts;
