"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpTest = void 0;
var tslib_1 = require("tslib");
var json_pointer_1 = require("../../json-pointer");
var AbstractPredicateOp_1 = require("./AbstractPredicateOp");
var isEqual = require('fast-deep-equal');
var OpTest = (function (_super) {
    tslib_1.__extends(OpTest, _super);
    function OpTest(path, value, not) {
        var _this = _super.call(this, 'test', path) || this;
        _this.value = value;
        _this.not = not;
        return _this;
    }
    OpTest.prototype.test = function (doc) {
        var val = json_pointer_1.find(doc, this.path).val;
        if (val === undefined)
            return !!this.not;
        var test = isEqual(val, this.value);
        return this.not ? !test : test;
    };
    OpTest.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
        if (this.not)
            op.not = this.not;
        return op;
    };
    OpTest.prototype.toPacked = function () {
        var packed = [5, this.path, { v: this.value }];
        if (this.not)
            packed[2].n = 1;
        return packed;
    };
    return OpTest;
}(AbstractPredicateOp_1.AbstractPredicateOp));
exports.OpTest = OpTest;
