"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpTestStringLen = void 0;
var tslib_1 = require("tslib");
var AbstractPredicateOp_1 = require("./AbstractPredicateOp");
var json_pointer_1 = require("../../json-pointer");
var OpTestStringLen = (function (_super) {
    tslib_1.__extends(OpTestStringLen, _super);
    function OpTestStringLen(path, len, not) {
        var _this = _super.call(this, 'test_string_len', path) || this;
        _this.len = len;
        _this.not = not;
        return _this;
    }
    OpTestStringLen.prototype.test = function (doc) {
        var val = json_pointer_1.find(doc, this.path).val;
        if (typeof val !== 'string')
            return false;
        var length = val.length;
        var test = val.length >= this.len;
        return this.not ? !test : test;
    };
    OpTestStringLen.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            len: this.len,
        };
        if (this.not)
            op.not = this.not;
        return op;
    };
    OpTestStringLen.prototype.toPacked = function () {
        var packed = [41, this.path, { l: this.len }];
        if (this.not)
            packed[2].n = 1;
        return packed;
    };
    return OpTestStringLen;
}(AbstractPredicateOp_1.AbstractPredicateOp));
exports.OpTestStringLen = OpTestStringLen;
