"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpType = void 0;
var tslib_1 = require("tslib");
var AbstractPredicateOp_1 = require("./AbstractPredicateOp");
var json_pointer_1 = require("../../json-pointer");
var isArray = Array.isArray;
var OpType = (function (_super) {
    tslib_1.__extends(OpType, _super);
    function OpType(path, value) {
        var _this = _super.call(this, 'type', path) || this;
        _this.value = value;
        return _this;
    }
    OpType.prototype.test = function (doc) {
        var val = json_pointer_1.find(doc, this.path).val;
        if (val === null)
            return this.value === 'null';
        if (isArray(val))
            return this.value === 'array';
        if (typeof val === this.value)
            return true;
        if (typeof val === 'number' && val === Math.round(val) && this.value === 'integer')
            return true;
        return false;
    };
    OpType.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
        return op;
    };
    OpType.prototype.toPacked = function () {
        var packed = [42, this.path, { v: this.value }];
        return packed;
    };
    return OpType;
}(AbstractPredicateOp_1.AbstractPredicateOp));
exports.OpType = OpType;
