"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpUndefined = void 0;
var tslib_1 = require("tslib");
var AbstractPredicateOp_1 = require("./AbstractPredicateOp");
var json_pointer_1 = require("../../json-pointer");
var OpUndefined = (function (_super) {
    tslib_1.__extends(OpUndefined, _super);
    function OpUndefined(path) {
        return _super.call(this, 'undefined', path) || this;
    }
    OpUndefined.prototype.test = function (doc) {
        try {
            var val = json_pointer_1.find(doc, this.path).val;
            var test_1 = val === undefined;
            return test_1;
        }
        catch (error) {
            if (error.message === 'NOT_FOUND')
                return true;
            throw error;
        }
    };
    OpUndefined.prototype.toJson = function () {
        var op = {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
        };
        return op;
    };
    OpUndefined.prototype.toPacked = function () {
        var packed = [38, this.path];
        return packed;
    };
    return OpUndefined;
}(AbstractPredicateOp_1.AbstractPredicateOp));
exports.OpUndefined = OpUndefined;
