"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.operationToPredicateOp = exports.operationToOp = exports.OpExtend = exports.OpMerge = exports.OpSplit = exports.OpStrDel = exports.OpStrIns = exports.OpInc = exports.OpFlip = exports.OpCopy = exports.OpMove = exports.OpReplace = exports.OpRemove = exports.OpAdd = exports.OpType = exports.OpMatches = exports.OpNot = exports.OpOr = exports.OpAnd = exports.OpMore = exports.OpLess = exports.OpIn = exports.OpStarts = exports.OpEnds = exports.OpContains = exports.OpTestStringLen = exports.OpTestString = exports.OpTestType = exports.OpUndefined = exports.OpDefined = exports.OpTest = exports.AbstractPredicateOp = void 0;
var tslib_1 = require("tslib");
var OpAdd_1 = require("./OpAdd");
Object.defineProperty(exports, "OpAdd", { enumerable: true, get: function () { return OpAdd_1.OpAdd; } });
var OpRemove_1 = require("./OpRemove");
Object.defineProperty(exports, "OpRemove", { enumerable: true, get: function () { return OpRemove_1.OpRemove; } });
var OpReplace_1 = require("./OpReplace");
Object.defineProperty(exports, "OpReplace", { enumerable: true, get: function () { return OpReplace_1.OpReplace; } });
var OpMove_1 = require("./OpMove");
Object.defineProperty(exports, "OpMove", { enumerable: true, get: function () { return OpMove_1.OpMove; } });
var OpCopy_1 = require("./OpCopy");
Object.defineProperty(exports, "OpCopy", { enumerable: true, get: function () { return OpCopy_1.OpCopy; } });
var OpTest_1 = require("./OpTest");
Object.defineProperty(exports, "OpTest", { enumerable: true, get: function () { return OpTest_1.OpTest; } });
var OpFlip_1 = require("./OpFlip");
Object.defineProperty(exports, "OpFlip", { enumerable: true, get: function () { return OpFlip_1.OpFlip; } });
var OpInc_1 = require("./OpInc");
Object.defineProperty(exports, "OpInc", { enumerable: true, get: function () { return OpInc_1.OpInc; } });
var OpStrIns_1 = require("./OpStrIns");
Object.defineProperty(exports, "OpStrIns", { enumerable: true, get: function () { return OpStrIns_1.OpStrIns; } });
var OpStrDel_1 = require("./OpStrDel");
Object.defineProperty(exports, "OpStrDel", { enumerable: true, get: function () { return OpStrDel_1.OpStrDel; } });
var OpSplit_1 = require("./OpSplit");
Object.defineProperty(exports, "OpSplit", { enumerable: true, get: function () { return OpSplit_1.OpSplit; } });
var OpMerge_1 = require("./OpMerge");
Object.defineProperty(exports, "OpMerge", { enumerable: true, get: function () { return OpMerge_1.OpMerge; } });
var OpExtend_1 = require("./OpExtend");
Object.defineProperty(exports, "OpExtend", { enumerable: true, get: function () { return OpExtend_1.OpExtend; } });
var OpDefined_1 = require("./OpDefined");
Object.defineProperty(exports, "OpDefined", { enumerable: true, get: function () { return OpDefined_1.OpDefined; } });
var OpUndefined_1 = require("./OpUndefined");
Object.defineProperty(exports, "OpUndefined", { enumerable: true, get: function () { return OpUndefined_1.OpUndefined; } });
var OpTestType_1 = require("./OpTestType");
Object.defineProperty(exports, "OpTestType", { enumerable: true, get: function () { return OpTestType_1.OpTestType; } });
var OpTestString_1 = require("./OpTestString");
Object.defineProperty(exports, "OpTestString", { enumerable: true, get: function () { return OpTestString_1.OpTestString; } });
var OpTestStringLen_1 = require("./OpTestStringLen");
Object.defineProperty(exports, "OpTestStringLen", { enumerable: true, get: function () { return OpTestStringLen_1.OpTestStringLen; } });
var OpContains_1 = require("./OpContains");
Object.defineProperty(exports, "OpContains", { enumerable: true, get: function () { return OpContains_1.OpContains; } });
var OpEnds_1 = require("./OpEnds");
Object.defineProperty(exports, "OpEnds", { enumerable: true, get: function () { return OpEnds_1.OpEnds; } });
var OpStarts_1 = require("./OpStarts");
Object.defineProperty(exports, "OpStarts", { enumerable: true, get: function () { return OpStarts_1.OpStarts; } });
var OpIn_1 = require("./OpIn");
Object.defineProperty(exports, "OpIn", { enumerable: true, get: function () { return OpIn_1.OpIn; } });
var OpLess_1 = require("./OpLess");
Object.defineProperty(exports, "OpLess", { enumerable: true, get: function () { return OpLess_1.OpLess; } });
var OpMore_1 = require("./OpMore");
Object.defineProperty(exports, "OpMore", { enumerable: true, get: function () { return OpMore_1.OpMore; } });
var OpAnd_1 = require("./OpAnd");
Object.defineProperty(exports, "OpAnd", { enumerable: true, get: function () { return OpAnd_1.OpAnd; } });
var OpOr_1 = require("./OpOr");
Object.defineProperty(exports, "OpOr", { enumerable: true, get: function () { return OpOr_1.OpOr; } });
var OpNot_1 = require("./OpNot");
Object.defineProperty(exports, "OpNot", { enumerable: true, get: function () { return OpNot_1.OpNot; } });
var OpMatches_1 = require("./OpMatches");
Object.defineProperty(exports, "OpMatches", { enumerable: true, get: function () { return OpMatches_1.OpMatches; } });
var OpType_1 = require("./OpType");
Object.defineProperty(exports, "OpType", { enumerable: true, get: function () { return OpType_1.OpType; } });
var json_pointer_1 = require("../../json-pointer");
var AbstractPredicateOp_1 = require("./AbstractPredicateOp");
Object.defineProperty(exports, "AbstractPredicateOp", { enumerable: true, get: function () { return AbstractPredicateOp_1.AbstractPredicateOp; } });
var operationToOp = function (op) {
    switch (op.op) {
        case 'add':
            return new OpAdd_1.OpAdd(json_pointer_1.toPath(op.path), op.value);
        case 'remove':
            return new OpRemove_1.OpRemove(json_pointer_1.toPath(op.path), op.oldValue);
        case 'replace':
            return new OpReplace_1.OpReplace(json_pointer_1.toPath(op.path), op.value, op.oldValue);
        case 'move':
            return new OpMove_1.OpMove(json_pointer_1.toPath(op.path), json_pointer_1.toPath(op.from));
        case 'copy':
            return new OpCopy_1.OpCopy(json_pointer_1.toPath(op.path), json_pointer_1.toPath(op.from));
        case 'flip':
            return new OpFlip_1.OpFlip(json_pointer_1.toPath(op.path));
        case 'inc':
            return new OpInc_1.OpInc(json_pointer_1.toPath(op.path), op.inc);
        case 'str_ins':
            return new OpStrIns_1.OpStrIns(json_pointer_1.toPath(op.path), op.pos, op.str);
        case 'str_del':
            return new OpStrDel_1.OpStrDel(json_pointer_1.toPath(op.path), op.pos, op.str, op.len);
        case 'split':
            return new OpSplit_1.OpSplit(json_pointer_1.toPath(op.path), op.pos, op.props || null);
        case 'merge':
            return new OpMerge_1.OpMerge(json_pointer_1.toPath(op.path), op.pos, op.props || null);
        case 'extend':
            return new OpExtend_1.OpExtend(json_pointer_1.toPath(op.path), op.props, !!op.deleteNull);
        default:
            return exports.operationToPredicateOp(op);
    }
};
exports.operationToOp = operationToOp;
var operationToPredicateOp = function (op) {
    switch (op.op) {
        case 'test':
            return new OpTest_1.OpTest(json_pointer_1.toPath(op.path), op.value, !!op.not);
        case 'defined':
            return new OpDefined_1.OpDefined(json_pointer_1.toPath(op.path));
        case 'undefined':
            return new OpUndefined_1.OpUndefined(json_pointer_1.toPath(op.path));
        case 'type':
            return new OpType_1.OpType(json_pointer_1.toPath(op.path), op.value);
        case 'test_type':
            return new OpTestType_1.OpTestType(json_pointer_1.toPath(op.path), op.type);
        case 'test_string':
            return new OpTestString_1.OpTestString(json_pointer_1.toPath(op.path), op.pos, op.str, !!op.not);
        case 'test_string_len':
            return new OpTestStringLen_1.OpTestStringLen(json_pointer_1.toPath(op.path), op.len, !!op.not);
        case 'contains':
            return new OpContains_1.OpContains(json_pointer_1.toPath(op.path), op.value, !!op.ignore_case);
        case 'ends':
            return new OpEnds_1.OpEnds(json_pointer_1.toPath(op.path), op.value, !!op.ignore_case);
        case 'starts':
            return new OpStarts_1.OpStarts(json_pointer_1.toPath(op.path), op.value, !!op.ignore_case);
        case 'matches':
            return new OpMatches_1.OpMatches(json_pointer_1.toPath(op.path), op.value, !!op.ignore_case);
        case 'in':
            return new OpIn_1.OpIn(json_pointer_1.toPath(op.path), op.value);
        case 'less':
            return new OpLess_1.OpLess(json_pointer_1.toPath(op.path), op.value);
        case 'more':
            return new OpMore_1.OpMore(json_pointer_1.toPath(op.path), op.value);
        case 'and':
            return new OpAnd_1.OpAnd(json_pointer_1.toPath(op.path), op.apply.map(function (x) { return exports.operationToPredicateOp(tslib_1.__assign(tslib_1.__assign({}, x), { path: tslib_1.__spread(op.path, json_pointer_1.toPath(x.path)) })); }));
        case 'or':
            return new OpOr_1.OpOr(json_pointer_1.toPath(op.path), op.apply.map(function (x) { return exports.operationToPredicateOp(tslib_1.__assign(tslib_1.__assign({}, x), { path: tslib_1.__spread(op.path, json_pointer_1.toPath(x.path)) })); }));
        case 'not':
            return new OpNot_1.OpNot(json_pointer_1.toPath(op.path), op.apply.map(function (x) { return exports.operationToPredicateOp(tslib_1.__assign(tslib_1.__assign({}, x), { path: tslib_1.__spread(op.path, json_pointer_1.toPath(x.path)) })); }));
        default:
            throw new Error('OP_UNKNOWN');
    }
};
exports.operationToPredicateOp = operationToPredicateOp;
