"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isElementNode = exports.isTextNode = exports.deepClone = void 0;
var isArray = Array.isArray;
var objectKeys = Object.keys;
function deepClone(obj) {
    if (!obj)
        return obj;
    if (isArray(obj)) {
        var arr = [];
        var length_1 = obj.length;
        for (var i = 0; i < length_1; i++)
            arr.push(deepClone(obj[i]));
        return arr;
    }
    else if (typeof obj === 'object') {
        var keys = objectKeys(obj);
        var length_2 = keys.length;
        var newObject = {};
        for (var i = 0; i < length_2; i++) {
            var key = keys[i];
            newObject[key] = deepClone(obj[key]);
        }
        return newObject;
    }
    return obj;
}
exports.deepClone = deepClone;
var isTextNode = function (node) {
    return !!node && typeof node === 'object' && typeof node.text === 'string';
};
exports.isTextNode = isTextNode;
var isElementNode = function (node) {
    return !!node && typeof node === 'object' && isArray(node.children);
};
exports.isElementNode = isElementNode;
