"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findByPointer = void 0;
var util_1 = require("../util");
var isArray = Array.isArray;
var findByPointer = function (pointer, val) {
    if (!pointer)
        return { val: val };
    var obj;
    var key;
    var indexOfSlash = 0;
    var indexAfterSlash = 1;
    while (indexOfSlash > -1) {
        indexOfSlash = pointer.indexOf('/', indexAfterSlash);
        var component = indexOfSlash > -1
            ? pointer.substring(indexAfterSlash, indexOfSlash)
            : pointer.substring(indexAfterSlash);
        indexAfterSlash = indexOfSlash + 1;
        key = util_1.unescapeComponent(component);
        obj = val;
        if (isArray(obj)) {
            if (key === '-')
                key = obj.length;
            else {
                if (!util_1.isValidIndex(key))
                    throw new Error('INVALID_INDEX');
                key = Number(key);
                if (key < 0)
                    throw new Error('INVALID_INDEX');
            }
            val = util_1.hasOwnProperty(obj, String(key)) ? obj[key] : undefined;
        }
        else if (typeof obj === 'object' && !!obj) {
            val = util_1.hasOwnProperty(obj, String(key)) ? obj[key] : undefined;
        }
        else
            throw new Error('NOT_FOUND');
    }
    return { val: val, obj: obj, key: key };
};
exports.findByPointer = findByPointer;
