"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findByPointer = void 0;
var util_1 = require("../util");
var isArray = Array.isArray;
var findByPointer = function (pointer, val) {
    if (!pointer)
        return [val, ''];
    var obj;
    var key;
    var indexOfSlash = 0;
    var indexAfterSlash = 1;
    while (indexOfSlash > -1) {
        indexOfSlash = pointer.indexOf('/', indexAfterSlash);
        key = indexOfSlash > -1
            ? pointer.substring(indexAfterSlash, indexOfSlash)
            : pointer.substring(indexAfterSlash);
        indexAfterSlash = indexOfSlash + 1;
        obj = val;
        if (isArray(obj)) {
            if (key === '-')
                key = obj.length;
            else {
                key = ~~key;
                if (key < 0)
                    throw 'INVALID_INDEX';
            }
            val = obj[key];
        }
        else if (typeof obj === 'object' && !!obj) {
            key = util_1.unescapeComponent(key);
            val = util_1.hasOwnProperty(obj, key) ? obj[key] : undefined;
        }
        else
            throw 'NOT_FOUND';
    }
    return [obj, key];
};
exports.findByPointer = findByPointer;
