"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonRpcRxServer = void 0;
var tslib_1 = require("tslib");
var util_1 = require("./util");
var JsonRpcRxServer = (function () {
    function JsonRpcRxServer(_a) {
        var call = _a.call, notify = _a.notify;
        this.call = call;
        this.notify = notify;
    }
    JsonRpcRxServer.prototype.onSubscribe = function (ctx, message) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _a, id, name, payload, result;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = tslib_1.__read(message, 3), id = _a[0], name = _a[1], payload = _a[2];
                        util_1.assertId(id);
                        util_1.assertName(name);
                        return [4, this.call(name, ctx, payload)];
                    case 1:
                        result = _b.sent();
                        return [2, [0, id, result]];
                }
            });
        });
    };
    JsonRpcRxServer.prototype.onNotification = function (ctx, message) {
        var _a = tslib_1.__read(message, 2), name = _a[0], payload = _a[1];
        util_1.assertName(name);
        this.notify(name, ctx, payload);
    };
    JsonRpcRxServer.prototype.onMessage = function (ctx, message) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _a, one, error_1, id;
            var _this = this;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 5, , 6]);
                        if (!util_1.isArray(message))
                            throw new Error('Invalid message');
                        if (!message.length)
                            return [2, null];
                        if (!util_1.isArray(message[0])) return [3, 2];
                        return [4, Promise.all(message.map(function (msg) { return _this.onMessage(ctx, msg); }))];
                    case 1: return [2, _b.sent()];
                    case 2:
                        _a = tslib_1.__read(message, 1), one = _a[0];
                        if (typeof one === 'string') {
                            this.onNotification(ctx, message);
                            return [2, null];
                        }
                        if (!(one > 0)) return [3, 4];
                        return [4, this.onSubscribe(ctx, message)];
                    case 3: return [2, _b.sent()];
                    case 4: throw new Error('Invalid message');
                    case 5:
                        error_1 = _b.sent();
                        id = util_1.isArray(message) && (typeof message[0] === 'number') && (message[0] > 0) && (Math.round(message[0]) === message[0])
                            ? message[0] : -1;
                        return [2, [-1, id, { message: error_1 instanceof Error ? error_1.message : String(error_1) }]];
                    case 6: return [2];
                }
            });
        });
    };
    return JsonRpcRxServer;
}());
exports.JsonRpcRxServer = JsonRpcRxServer;
